#!/usr/bin/perl
#Script that needs to be run on gcc-compiled .s19 files for the Axiom
#PB-0555 board.  It seems that the board's simplistic program-loader
#will _only_ take S3/S7 records, even though gcc may output S1's or S2's.

$file = $ARGV[0];

if ($file eq "") {
  print "Usage: fixsrec.pl <file>\n";
  exit;
}

if (!(-f $file)) {
  print "$file doesn't exist\n";
  exit;
}

$file2 = "$file.aa$$";
($perm,$uid,$gid) = (stat($file))[2,4,5];

open(A,"$file");
open(B,">$file2");
while ($line = <A>) {
  chomp($line);
  $line =~ s/\015$//g;
  if ($line =~ /^S2/) {
    @chars = split(//, $line);
    $size = hex($chars[2] . $chars[3]);
    $size++;
    $line = 'S3' . sprintf("%02X", $size) . '00';
    for ($i = 4; $i <= $#chars; $i++) {
      $line .= $chars[$i];
    }
    $addr = hex($chars[4] . $chars[5] . $chars[6] . $chars[7] . $chars[8] . $chars[9]);
    if ($addr < hex("10000") || $addr >= hex("400000")) {
      next;
    }
  }
  elsif ($line =~ /^S3/) {
    @chars = split(//, $line);
    $addr = hex($chars[4] . $chars[5] . $chars[6] . $chars[7] . $chars[8] . $chars[9] . $chars[10] . $chars[11]);
    if ($addr < hex("10000") || $addr >= hex("400000")) {
      next;
    }
  }
  elsif ($line =~ /^S8/) {
    @chars = split(//, $line);
    $size = hex($chars[2] . $chars[3]);
    $size++;
    $line = 'S7' . sprintf("%02X", $size) . '00';
    for ($i = 4; $i <= $#chars; $i++) {
      $line .= $chars[$i];
    }
  }
  print B "$line\n";
}
close(A);
close(B);

chmod $perm, $file2;
chown $uid, $gid, $file2;

rename $file2, $file;


