
#include "hw.h"

extern void puts2(char *sptr);

unsigned int interrupt;


typedef unsigned char UNS8;
typedef unsigned short UNS16;
typedef unsigned long UNS32;


#ifndef put8
#define put8(p, x)      ((*((volatile UNS8*)(p))) = (x))
#endif
#ifndef put16
#define put16(p, x)     ((*((volatile UNS16*)(p))) = (x))
#endif
#ifndef put32
#define put32(p, x)     ((*((volatile UNS32*)(p))) = (x))
#endif
                                                         
#ifndef get8
#define get8(p)         (*((volatile UNS8*)(p)))         
#endif
#ifndef get16
#define get16(p)        (*((volatile UNS16*)(p)))
#endif
#ifndef get32
#define get32(p)        (*((volatile UNS32*)(p)))
#endif


//---------------------------------------------------------------------------
// INITIALIZE HARDWARE REGISTERS                                             
// This routine is called once following RESET
void inithw(){
        unsigned long *Rptr;
        unsigned short *sRptr;
        
        put32(0x2fc000,0x420800);       // SIUMCR make irq's general purpose i/o
        
//      put32(0x2fc000,0x420000);       // SIUMCR make irq's irq, NOT TESTED
        
    put32(0x2fc004,0x00FF88);   // SYPCR                    
        
        put32(0x2fc100,0x400003);       // BR0 32-bit set here for BDM or external flash                                                                       
        put32(0x2fc104,0xfff80022);     // OR0 2 wait states
//      put32(0x2fc104,0xfff80012);     // OR0 1 wait state
//      put32(0x2fc104,0xfff800f2);     // OR0 15 wait states

        put32(0x2fc108,0x800003);       // BR1
        put32(0x2fc10c,0xfff80002);     // OR1
        put32(0x2fc110,0xc00003);       // BR2
        put32(0x2fc114,0xfffe0022);     // OR2
        put32(0x2fc118,0x01000403);     // BR3 Keypad/LCD
        put32(0x2fc11c,0xfffe0FF1);     // OR3 maximum wait states
        put32(0x2fc140,0x00000000);     // DMBR
        put32(0x2fc144,0x00000000);     // DMOR
        put32(0x2fc280,0x10000);        // SCCR
        put32(0x2fc284,0x400000);       // PLPRCR 20mhz
//      put32(0x2fc284,0x900000);       // PLPRCR 40mhz

        put16(0x300000,0x00);   // DPT
        put16(0x300004,0xffa0); // RAM base addr
        put16(0x305014,0x00);   // PORTQS
        put16(0x305016,0x00);   // PQSPAR/DDRQS
        put16(0x306100,0x00);   // MPIOSMDR
        put16(0x306102,0x00);   // MPIOSMDDR
        put16(0x306800,0x00);   // MPIOS1TPCR
        put16(0x380000,0x00);   // SRAMMCR

        put32(0x2fc024,0x00);   // SGPIODT1
        put32(0x2fc028,0x00);   // SGPIODT2
        put32(0x2fc02c,0x00);   // SGPIOCR
        put32(0x2fc030,0x00);   // EMCR
        put32(0x307f80,0x00);   // UMCR

    put32(0x2fc014, 0x1000000);    //SIU Interrupt Mask Register SIMASK
                                    //Currently set for level 3. I don't
                                    //Really understand this yet.

/*
Played with PITC routine and interrupts

    put32(0x2fc244, 0xFFFF0000);    // PITC Count Register
                                    // This set the count register to the max

    put16(0x2fc240, 0x1C05);        // PITC Count Register
                                    // This configures the PIC timer

    asm ("mtspr 80, %r0");      //Enables external interrupts
                                    // EIE is equiv to 80

                                                                        */
}

void DEC_Hdlr (void)
{
        asm ("  mtspr   81,%r0");   // Disables interupts

    interrupt = get32(0x2FC010);

    put16(0x2fc240, 0x1C85);    // PITC Count Register
                                // This writes a 1 to the PS in PITC register

    puts2(".");

//      asm ("  mtspr   80,%r0");   // Enables interrupts
// I don't think I should do this here.  rfi should do the same.

}

