
#include <errno.h>

/* just in case, most boards have at least some memory */
#ifndef RAMSIZE
#  define RAMSIZE             (caddr_t)0x100000
#endif

#include "serial.h"

//extern char end[];
extern char __HEAP_END[];
char *heap_ptr;

/*
 * sbrk -- changes heap size size. Get nbytes more
 *         RAM. We just increment a pointer in what's
 *         left of memory on the board.
 */
char *
sbrk (
     int nbytes)
{
  char        *base;

  puts2("growing heap...\n");

  if (!heap_ptr)
    heap_ptr = (char *)&__HEAP_END;
//    heap_ptr = (char *)&end;
  base = heap_ptr;
  heap_ptr += nbytes;

  return base;
/* FIXME: We really want to make sure we don't run out of RAM, but this
 *       isn't very portable.
 */
#if 0
  if ((RAMSIZE - heap_ptr - nbytes) >= 0) {
    base = heap_ptr;
    heap_ptr += nbytes;
    return (base);
  } else {
    errno = ENOMEM;
    return ((char *)-1);
  }
#endif
}


